#ifndef SERIAL_H
#define SERIAL_H

#define BAUD 38400
#define BUFFER_SIZE 128

#include <util/setbaud.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>

class Serial
{
private:
    char _terminator = '\n';
    uint16_t _rxIndex=0;
    
public:
    Serial();
    void putChar(const char c);
    void putString(const char* in, const unsigned int length);
    void putString(const char in[]);
    bool dataIsWaiting();
    char getChar();
    unsigned int getString(char* buffer, const int bufferLength);
    void flush();    
    void setTerminator(const char terminator);
};

#endif

